﻿using Syncfusion.Windows.Reports.Designer;
using Syncfusion.Windows.Tools.Controls;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Windows;
using System.Windows.Automation.Peers;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Media;

namespace ReportdesignerMVVM
{
    public class DesignerViewModel
    {
        ReportDesigner ReportDesignerControl;
        RibbonButton previewButton = null;
        public DesignerViewModel(ReportDesignView ReportDesignView)
        {
            ReportDesignView.Loaded += ReportDesignView_Loaded;  
        }

        private void ReportDesignView_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
            ReportDesignerControl = (sender as ReportDesignView).ReportDesignerControl;
            ReportDesignerControl.Loaded += ReportDesignerControl_Loaded;
        }

        private void ReportDesignerControl_Loaded(object sender, System.Windows.RoutedEventArgs e)
        {
           if(ReportDesignerControl.Ribbon.Items.Count > 0)
            {
                foreach (var item in ReportDesignerControl.Ribbon.Items)
                {
                    if(item is RibbonTab)
                    {
                        RibbonTab ribbonTab = item as RibbonTab;
                        foreach (var ribbonTabItem in ribbonTab.Items)
                        {
                           if(ribbonTabItem is RibbonBar)
                            {
                                RibbonBar bar = ribbonTabItem as RibbonBar;
                                foreach (var barItem in bar.Items)
                                {
                                    if(barItem is RibbonButton)
                                    {
                                        RibbonButton ribbonButton = barItem as RibbonButton;

                                        if (ribbonButton.Label == "Preview")
                                        {
                                            previewButton = ribbonButton;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            RibbonTab customRibbonTab = new RibbonTab() { Caption = "CustomTab" };
            RibbonBar ribbonBar = new RibbonBar();
            RibbonButton customPreviewButton = new RibbonButton() { Label = "CustomPreviewButton" };
            ribbonBar.AddItem(customPreviewButton, new Syncfusion.Windows.Tools.RibbonDynamicItemInfo());
            customRibbonTab.AddItem(ribbonBar, new Syncfusion.Windows.Tools.RibbonDynamicItemInfo());
            ReportDesignerControl.Ribbon.AddItem(customRibbonTab, new Syncfusion.Windows.Tools.RibbonDynamicItemInfo());
            customPreviewButton.Click += CustomPreviewButton_Click;
        }

        private void CustomPreviewButton_Click(object sender, RoutedEventArgs e)
        {
            previewButton.RaiseEvent(new RoutedEventArgs(ButtonBase.ClickEvent));
        }
    }
}
